<?php # Script 17.x - se_read.php
// This page shows the messages in a thread.
// This is the search engine version, without any HTML!

// Created by Larry Ullman, www.LarryUllman.com
// Associated with the content from Chapter 17 of the book "PHP and MySQL for Dynamic Web Sites: Visual QuickPro Guide (4th Edition)".
// The other scripts and SQL commands that go with this code can be downloaded from the book's corresponding Web site at www.LarryUllman.com.

// Need the database connection:
require ('../mysqli_connect.php');

// Check for a thread ID...
$tid = FALSE;
if (isset($_GET['tid']) && filter_var($_GET['tid'], FILTER_VALIDATE_INT, array('min_range' => 1)) ) {
	
	// Create a shorthand version of the thread ID:
	$tid = $_GET['tid'];
	
	// Run the query:
	$q = "SELECT t.subject, p.message, username FROM threads AS t LEFT JOIN posts AS p USING (thread_id) INNER JOIN users AS u ON p.user_id = u.user_id WHERE t.thread_id = $tid ORDER BY p.posted_on ASC";
	$r = mysqli_query($dbc, $q);
	if (!(mysqli_num_rows($r) > 0)) {
		$tid = FALSE; // Invalid thread ID!
	}
	
} // End of isset($_GET['tid']) IF.

if ($tid) { // Get the messages in this thread...
	
	$printed = FALSE; // Flag variable.

	// Fetch each:
	while ($messages = mysqli_fetch_array($r, MYSQLI_ASSOC)) {

		// Only need to print the subject once!
		if (!$printed) {
			echo $messages['subject'] . ' ';
			$printed = TRUE;
		}
	
		// Print the message:
		echo "{$messages['username']} {$messages['message']} \n";

	} // End of WHILE loop.
		
} else { // Invalid thread ID!
	echo 'This page has been accessed in error.';
}
?>