<?php # Script 17.8x - search.php
// This page displays and handles a search form.

// Created by Larry Ullman, www.LarryUllman.com
// Associated with the content from Chapter 17 of the book "PHP and MySQL for Dynamic Web Sites: Visual QuickPro Guide (4th Edition)".
// The other scripts and SQL commands that go with this code can be downloaded from the book's corresponding Web site at www.LarryUllman.com.

// Include the HTML header:
include ('includes/header.html');

// Show the search form:
echo '<form action="search.php" method="get" accept-charset="utf-8">
<p><em>Search</em>: <input name="terms" type="text" size="30" maxlength="60" ';
	
// Check for existing value:
if (isset($_GET['terms'])) {
	echo 'value="' . htmlspecialchars($_GET['terms']) . '" ';
}

// Complete the form:
echo '/><input name="submit" type="submit" value="' . $words['submit'] . '" /></p></form>';

echo '<h2>Search Results</h2><ul>';

if (isset($_GET['terms'])) { // Handle the form.
	
	// Clean the terms:
	$terms = mysqli_real_escape_string($dbc, strip_tags(strtolower($_GET['terms'])));
	
	// Break the terms into words:
	$terms = explode(' ', $terms);

	// Build up the query:
	$q = 'SELECT p.page_url, SUM(pw.frequency) AS relevance FROM se_pages AS p INNER JOIN se_pages_words AS pw USING (page_id) INNER JOIN se_words AS w USING (word_id) WHERE';
	foreach ($terms as $term) {
	    $q .= " word='$term' OR";
	}
	// Drop off the last OR:
	$q = substr($q, 0, -3);

	// Add the GROUP BY and ORDER BY:
	$q .= ' GROUP BY pw.page_id ORDER BY relevance DESC';

	// Run the query:
	$r = mysqli_query($dbc, $q);
	if (mysqli_num_rows($r) > 0) { // Show the results!
		while ($row = mysqli_fetch_array($r, MYSQLI_NUM)) {
			echo "<li><a href=\"$row[0]\">$row[0]</a> ($row[1])</li>\n";
		}
		echo '</ul>';
	} else {
		echo '<p>No results found.</p>';
	}

}

// Include the HTML footer file:
include ('includes/footer.html');
?>
